// TweetingBitPlant-App
// by www.olafval.de

import twitter4j.conf.*;
import twitter4j.api.*;
import twitter4j.*;

import java.util.List;
import java.util.Iterator;

import controlP5.*;
ControlP5 cp5;

import processing.serial.*;

// The serial port:
Serial arduinoPort;
int comPortSelected = 0;

ConfigurationBuilder   cb;
Query query;
Twitter twitter;

ArrayList<UserCustom> twittersList;
Timer             time;

//Number twitters per search (10)
int numberSearch = 1;
String oneTweet = ""; 
String currentTweet = "";
int dimmNewTweet = 0;

int lastTweet = 0;

PFont font;
int   fontSize = 14;

PImage logo;
PImage setupIcon;

String screenName;

String version = "1.0";
// 0=firstStart(noData), 1=openSetup, 2=setup, 3=openNormal+saveSetup, 4=normal(running), 5=openPause, 6=pause, 7=openNormal(running)
int modus = 0; 
int testModus = 0;
int testModusOnce = 0;
int wiringModus = 0;
int wiringModus1 = 0;
//int wiringModusOnce = 0;

//int connecting = 0;

String ConsumerKey = "";
String ConsumerSecret = "";
String AccessToken = "";
String AccessTokenSecret = "";

String[] list = new String[8];

int cKey = 0; // command key pressend

DropdownList deviceList;

void setup() {
  size(200, 125);
  frame.setResizable(true);
  background(0);
  smooth(4);

  //FONT
  font = createFont("ArialUnicodeMS-14.vlw", fontSize, true);
  textFont(font, fontSize);

  //LOGO
  logo = loadImage("TweetingBitPlant-Logo-blau.png");

  //Setup Icon
  setupIcon = loadImage("setup.png");

  //You can only search once every 1 minute
  time = new Timer(70000); //1 min with 10 secs

  loadData();
  findSerialPort();

  //Acreditacion
  cb = new ConfigurationBuilder();
  cb.setOAuthConsumerKey(ConsumerKey);
  cb.setOAuthConsumerSecret(ConsumerSecret);
  cb.setOAuthAccessToken(AccessToken);
  cb.setOAuthAccessTokenSecret(AccessTokenSecret);

  //Make the twitter object and prepare the query
  twitter = new TwitterFactory(cb.build()).getInstance();

  //SEARCH
  twittersList = queryTwitter(numberSearch);

  if (screenName != null) {
    modus = 4;
  }

  // setUp GUI
  cp5 = new ControlP5(this);

  // myDeviceList
  deviceList = cp5.addDropdownList("myDeviceList")
    .setPosition(210, 120)
      .setSize(180, 200);
  customize(deviceList);
}

void draw() {

  // 0=firstStart(noData), 1=openSetup, 2=setup, 3=openNormal+saveSetup, 4=normal(running), 5=openPause, 6=pause, 7=openNormal(running)
  if (modus == 1) {
    modus = 2;

    // load data
    loadData();

    frame.setSize(400, 550);

    // ConsumerKey
    cp5 = new ControlP5(this);
    cp5.addTextfield("fConsumerKey")
      .setPosition(10, 290)
        .setSize(380, 14)
          .setFont(10)
            .setFocus(true)
              .setColor(color(255))
                .setColorBackground(230)
                  .setColorCaptionLabel(10) 
                    .setText(ConsumerKey)
                      .setLabel("Consumer Key");

    // ConsumerSecret
    cp5.addTextfield("fConsumerSecret")
      .setPosition(10, 290+(50*1))
        .setSize(380, 14)
          .setColor(color(255))
            .setColorBackground(230)
              .setColorCaptionLabel(10) 
                .setText(ConsumerSecret)
                  .setLabel("Consumer Secret");

    // AccessToken
    cp5.addTextfield("fAccessToken")
      .setPosition(10, 290+(50*2))
        .setSize(380, 14)
          .setColor(color(255))
            .setColorBackground(230)
              .setColorCaptionLabel(10) 
                .setText(AccessToken)
                  .setLabel("Access Token");

    // AccessTokenSecret
    cp5.addTextfield("fAccessTokenSecret")
      .setPosition(10, 290+(50*3)) // 280+
        .setSize(380, 14)
          .setColor(color(255))
            .setColorBackground(230)
              .setColorCaptionLabel(10) 
                .setText(AccessTokenSecret)
                  .setLabel("Access Token Secret");

    // Import from Chlipboard Button
    cp5.addButton("impConsumerKey")
      .setPosition(290, 290 + 18)
        .setSize(100, 15)
          .setLabel("Paste from clipboard");

    // Import from Chlipboard Button
    cp5.addButton("impConsumerSecret")
      .setPosition(290, 290 + 18 + (50*1))
        .setSize(100, 15)
          .setLabel("Paste from clipboard");

    // Import from Chlipboard Button
    cp5.addButton("impAccessToken")
      .setPosition(290, 290 + 18 + (50*2))
        .setSize(100, 15)
          .setLabel("Paste from clipboard");

    // Import from Chlipboard Button
    cp5.addButton("impAccessTokenSecret")
      .setPosition(290, 290 + 18 + (50*3))
        .setSize(100, 15)
          .setLabel("Paste from clipboard");
  }
  if (modus == 3) {
    // save data
    // ConsumerKey ConsumerSecret AccessToken AccessTokenSecret
    ConsumerKey = cp5.get(Textfield.class, "fConsumerKey").getText();
    list[0] = ConsumerKey;
    ConsumerSecret = cp5.get(Textfield.class, "fConsumerSecret").getText();
    list[1] = ConsumerSecret;
    AccessToken = cp5.get(Textfield.class, "fAccessToken").getText();
    list[2] = AccessToken;
    AccessTokenSecret = cp5.get(Textfield.class, "fAccessTokenSecret").getText();
    list[3] = AccessTokenSecret;
    
    list[4] = str(testModus);
    list[5] = str(wiringModus);
    list[6] = str(wiringModus1);
    list[7] = str(comPortSelected);
    saveStrings("TweetingBitPlantSetupData.txt", list);

    modus = 4;
    frame.setSize(200, 150);
  }
  if (modus == 5) {
    // pause tweeting
    modus = 6;
  }
  if (modus == 7) {
    // start tweeting
    modus = 4;
  }

  if (modus == 8) {
    // start testModus
    modus = 9;
  }
  background(255, 255, 255);

  noTint();
  image(logo, 10, 30);

  // setupIcon
  if ( (mouseX > 200-30) && (mouseY > 125-30) && (mouseX < 200) && (mouseY < 125) ) {
    noTint();
  } else {
    tint(255, 125);
  }
  image(setupIcon, 200 - 30, 125 - 30, 25, 25);

  // version
  if ( (mouseX > 10) && (mouseX < 10 + textWidth("Version " + version) ) && (mouseY > 110) && (mouseY < 125) ) {
    fill(130);
  } else {
    fill(200);
  }
  textAlign(LEFT);
  textSize(10);
  text("Version " + version, 10, 125 - 5);

  mainButton();

  if (modus == 2) {
    setupForm();
  }
  if (testModus == 0) {
    drawTwitters(twittersList);
    if (currentTweet.equals(oneTweet) == false) {
      currentTweet = oneTweet;
      dimmNewTweet = 0;
      arduinoPort.write(oneTweet);
      arduinoPort.write(10);
    }
    dimmNewTweet++;
    if (dimmNewTweet > 255) dimmNewTweet = 255;
    fill(dimmNewTweet);
    textSize(9);
    textAlign(LEFT);
    text(oneTweet, 10, 10);
  } else {
    // Test Modus ! ! !
    if (int(random(1000)) == 1) {
      testModusOnce = 0;
    }
    if (testModusOnce == 0) {
      arduinoPort.write("This is a test tweet to the TweetingBitPlant #test #tweet @bitplant");
      arduinoPort.write(10);
      testModusOnce = 1;
    }
  }

  if (time.isDone()) {
    twittersList = queryTwitter(numberSearch);
    time.reset();
  }

  //text(time.getCurrentTime(), width - fontSize*8, 40);

  time.update();
} // end draw

void mousePressed() {
  // 0=firstStart(noData), 1=openSetup, 2=setup, 3=saveSetup+openNormal, 4=normal(running), 5=openPause, 6=pause, 7=openNormal(running)

  // Button
  if ( (mouseX > (200/2)-(90/2) ) && (mouseX < (200/2)+90/2) && (mouseY > 70) && (mouseY < 70+30) ) {
    if (testModus == 0) {
      if (modus == 0) modus = 1;
      if (modus == 2) modus = 3;
      if (modus == 4) modus = 5;
      if (modus == 6) modus = 7;
    } else {
      testModusOnce = 0;
    }
  }

  // version
  if ( (mouseX > 10) && (mouseX < 10 + textWidth("Version " + version) ) && (mouseY > 110) && (mouseY < 125) ) {
    link("http://www.olafval.de/tweetingbitplant");
  }

  // Setup Button
  if ( (mouseX > 200-30) && (mouseY > 125-30) && (mouseX < 200) && (mouseY < 125) ) {

    if ( (modus == 0) || (modus == 4) || (modus == 6) ) {
      modus = 1;
    }
    if (modus == 2) {
      modus = 3;
    }
  }

  // Test Modus
  if ( (mouseX>210) && (mouseX<210+14) && (mouseY>15) && (mouseY<15+14) ) {
    if (testModus == 0) { 
      testModus = 1;
    } else {
      testModus = 0;
    }
  }

  // Wiring Modus + -
  if ( (mouseX>210) && (mouseX<210+14) && (mouseY>45) && (mouseY<45+14) ) {
    if (wiringModus == 0) { 
      wiringModus = 1;
      arduinoPort.write(16); // ASCII 16=DEL, 27=ESC
      arduinoPort.write(10);
      println("Wiring + - sende 16");
    } else {
      wiringModus = 0;
      println("Wiring + - sende 27");
      arduinoPort.write(27); // ASCII 16=DEL, 27=ESC
      arduinoPort.write(10);
    }
  }

  // Wiring Modus led <--> piezo
  if ( (mouseX>210) && (mouseX<210+14) && (mouseY>75) && (mouseY<75+14) ) {
    if (wiringModus1 == 0) { 
      wiringModus1 = 1;
      arduinoPort.write(30); 
      arduinoPort.write(10);
    } else {
      wiringModus1 = 0;
      arduinoPort.write(31); 
      arduinoPort.write(10);
    }
  }

  // link to USB driver
  if ((mouseX>10) && (mouseX<textWidth("1. Install the USB-driver - LINK")+5) && (mouseY>150-10) && (mouseY<(150-10)+12)) {
    link("http://tweetingbitplant.blogspot.de/2015/05/usb-treiber.html");
  }
  // link to twitter new app
  if ((mouseX>10) && (mouseX<textWidth("4. Go to: https://apps.twitter.com/app/new")+5) && (mouseY>150+(3*14)-10) && (mouseY<(150+(3*14)-10)+12)) {
    link("https://apps.twitter.com/app/new");
  }

  // Test Connection Button
  // frame
  if ( (mouseX > 10) && (mouseX < 10+90) && (mouseY > 490) && (mouseY < 490+30) ) {
    // test connection
    screenName = null;
    ConsumerKey = cp5.get(Textfield.class, "fConsumerKey").getText();
    ConsumerSecret = cp5.get(Textfield.class, "fConsumerSecret").getText();
    AccessToken = cp5.get(Textfield.class, "fAccessToken").getText();
    AccessTokenSecret = cp5.get(Textfield.class, "fAccessTokenSecret").getText();
    //Acreditacion
    cb = new ConfigurationBuilder();
    cb.setOAuthConsumerKey(ConsumerKey);
    cb.setOAuthConsumerSecret(ConsumerSecret);
    cb.setOAuthAccessToken(AccessToken);
    cb.setOAuthAccessTokenSecret(AccessTokenSecret);

    //Make the twitter object and prepare the query
    twitter = new TwitterFactory(cb.build()).getInstance();

    //SEARCH
    twittersList = queryTwitter(numberSearch);
  }
}

void setupForm() {
  stroke(150);
  line(0, 125, 400, 125);
  line(200, 0, 200, 125);

  // Checkbox: Test / Random Mode
  noFill();
  stroke(150);
  // []
  rect(210, 15, 14, 14);
  // x
  if (testModus == 1) {
    line(210, 15, 210+14, 15+14);
    line(210, 15+14, 210+14, 15);
  }
  // Text
  textAlign(LEFT);
  text("Test / Random Modus", 210+20, 15+13);

  // Checkbox: Invert + and - wiring
  noFill();
  stroke(150);
  // []
  rect(210, 45, 14, 14);
  // x
  if (wiringModus == 1) {
    line(210, 45, 210+14, 45+14);
    line(210, 45+14, 210+14, 45);
  }
  // Text
  textAlign(LEFT);
  text("Invert Wiring (+ -)", 210+20, 45+13);

  // Checkbox: led <--> piezo
  noFill();
  stroke(150);
  // []
  rect(210, 75, 14, 14);
  // x
  if (wiringModus1 == 1) {
    line(210, 75, 210+14, 75+14);
    line(210, 75+14, 210+14, 75);
  }
  // Text
  textAlign(LEFT);
  text("Led <--> Piezo", 210+20, 75+13);

  // Instrution
  textSize(11);
  text("1. Install the USB-driver - LINK", 10, 150);
  text("2. Make sure you are signed in to your twitter account", 10, 150+ 14);
  text("3. Make sure your mobile phone is registered in your twitter account", 10, 150+ (14*2));
  text("4. Go to: https://apps.twitter.com/app/new", 10, 150+ (14*3));
  text("5. Name: TweetingBitPlant, Description: Twitter-Notifier", 10, 150+ (14*4));
  text("6. Website: http://www.olafval.de/tbp, Callback URL -leave blank-", 10, 150+ (14*5));
  text("7. Agree to the developer agreement and creat your Twitter application", 10, 150+ (14*6));
  text("8. Click on -manage keys and access tokens-", 10, 150+ (14*7));
  text("9. Click on -create my access token-", 10, 150+ (14*8));
  text("10. Copy the four keys to the form below and press the connect button", 10, 150+ (14*9));

  // Roll over text links
  noStroke();
  fill(204, 214, 221, 60);
  // USB driver
  if ((mouseX>10) && (mouseX<textWidth("1. Install the USB-driver - LINK")+5) && (mouseY>150-10) && (mouseY<(150-10)+12)) {
    rect(10, 150 - 10, textWidth("1. Install the USB-driver - LINK")+5, 12);
  }
  // link to twitter new app
  if ((mouseX>10) && (mouseX<textWidth("4. Go to: https://apps.twitter.com/app/new")+5) && (mouseY>150+(3*14)-10) && (mouseY<(150+(3*14)-10)+12)) {
    rect(10, 150+(3*14) - 10, textWidth("4. Go to: https://apps.twitter.com/app/new")+5, 12);
  }

  // Test Connection Button
  // frame
  if ( (mouseX > 10) && (mouseX < 10+90) && (mouseY > 490) && (mouseY < 490+30) ) {
    fill(204, 214, 221, 60);
  } else {
    fill(204, 214, 221, 30);
  }
  stroke(204, 214, 221);
  rect(10, 490, 90, 30, 4);
  // text
  fill(0);
  noStroke();
  textFont(font, 14);
  textAlign(LEFT);
  text("CONNECT", 20, 490+22);

  // Twitter ScreenName
  textAlign(LEFT);
  if (screenName == null) {
    text("No Connection!", 120, 490+22);
  } else {
    text("Connected with: " + screenName, 120, 490+22);
  }
}

void mainButton() {
  // Button
  // frame
  if ( (mouseX > (200/2)-(90/2) ) && (mouseX < (200/2)+90/2) && (mouseY > 70) && (mouseY < 70+30) ) {
    fill(204, 214, 221, 60);
  } else {
    fill(204, 214, 221, 30);
  }
  stroke(204, 214, 221);
  rect((200/2)-(90/2), 70, 90, 30, 4);
  // text
  fill(0);
  noStroke();
  textFont(font, 14);
  textAlign(CENTER);
  // 0=firstStart(noData), 1=openSetup, 2=setup, 3=openNormal+saveSetup, 4=normal(running), 5=openPause, 6=pause, 7=openNormal(running)

  if (testModus == 1) {
    text("TEST", 200/2, 90);
  } else {
    if (modus == 0) text("SETUP", 200/2, 90);
    if (modus == 2) text("SAVE", 200/2, 90);
    if (modus == 4) text("PAUSE", 200/2, 90);
    if (modus == 6) text("START", 200/2, 90);
  }
}

void drawTwitters(ArrayList<UserCustom> tw) {
  Iterator<UserCustom> it = tw.iterator();
  int i = 0;

  while (it.hasNext ()) {
    UserCustom usr = it.next();
    usr.draw( 30, 70 + i*fontSize*4);
    i++;
  }
}

ArrayList<UserCustom> queryTwitter(int nSearch) {
  ArrayList<UserCustom> twitt = new ArrayList<UserCustom>();

  try 
  {
    println("10 Twitter timeline");
    User user = twitter.verifyCredentials();
    screenName = "@"+user.getScreenName();

    Paging paging = new Paging(1, 10);
    List<Status> statuses = twitter.getHomeTimeline(paging);
    lastTweet = 0;
    for (Status status : statuses) {
      String usr = "@"+status.getUser().getName();
      String msg =  status.getText();
      if (lastTweet == 0) {
        oneTweet = status.getText();
        lastTweet = 1;
      }
      twitt.add(new UserCustom(usr, msg, fontSize));
    }
  }
  catch(TwitterException te) {
    println("Couldn't connect: " + te);
  }

  return twitt;
}

public void impConsumerKey() {
  ConsumerKey = "";
  ConsumerKey = GClip.paste();
  cp5.get(Textfield.class, "fConsumerKey").setText(ConsumerKey);
}

public void impConsumerSecret() {
  ConsumerSecret = "";
  ConsumerSecret = GClip.paste();
  cp5.get(Textfield.class, "fConsumerSecret").setText(ConsumerSecret);
}

public void impAccessToken() {
  AccessToken = "";
  AccessToken = GClip.paste();
  cp5.get(Textfield.class, "fAccessToken").setText(AccessToken);
}

public void impAccessTokenSecret() {
  AccessTokenSecret = "";
  AccessTokenSecret = GClip.paste();
  cp5.get(Textfield.class, "fAccessTokenSecret").setText(AccessTokenSecret);
}

void loadData() {
  String list[] = loadStrings("TweetingBitPlantSetupData.txt");
  if (list != null) {
    ConsumerKey = list[0];
    ConsumerSecret = list[1];
    AccessToken = list[2];
    AccessTokenSecret = list[3];

    testModus = int(list[4]);
    wiringModus = int(list[5]);
    wiringModus1 = int(list[6]);
    comPortSelected = int(list[7]);
  }
}

void keyPressed() {
  if (key == CODED) {
    if ( (keyCode == 157) || (keyCode == 17) || (keyCode == ALT) ) {
      cKey = 1;
    }
  }
  if ( (cKey == 1) && (key == 'v') ) {
    // if (key == 'd') clearAll();
    // if (key == 'c') copyClipboard();

    if (cp5.get(Textfield.class, "fConsumerKey").isFocus() ) {
      impConsumerKey();
    }
    if (cp5.get(Textfield.class, "fConsumerSecret").isFocus() ) {
      impConsumerSecret();
    }
    if (cp5.get(Textfield.class, "fAccessToken").isFocus() ) {
      impAccessToken();
    }
    if (cp5.get(Textfield.class, "fAccessTokenSecret").isFocus() ) {
      impAccessTokenSecret();
    }
  }
}
// ConsumerKey ConsumerSecret AccessToken AccessTokenSecret

void findSerialPort() {
  // Find Serial Port that the arduino is on 
  // The arduino is sending out a 'T' every 100 millisecs and 
  // checks to see if it got a 'G' back. 
  long millisStart; 
  int i = 0; 
  int len = Serial.list().length;  //get number of ports available 
  println(Serial.list());   //print list of ports to screen
  println(" -- ");
  println("Selected: " + Serial.list()[2]);
  // println("Serial Port Count = " + len); //print count of ports to screen
  arduinoPort = new Serial(this, Serial.list()[comPortSelected], 9600);
}

void controlEvent(ControlEvent theEvent) {

  if (theEvent.isGroup()) {
    // check if the Event was triggered from a ControlGroup
    //println("event from group : "+ theEvent.getGroup().getValue() +" from "+theEvent.getGroup());
    comPortSelected = int( theEvent.getGroup().getValue() );
    println("COM PORT Selected: " + comPortSelected);
    arduinoPort.stop();
    arduinoPort = new Serial(this, Serial.list()[comPortSelected], 9600);
  } else if (theEvent.isController()) {
    println("event from controller : "+theEvent.getController().getValue()+" from "+theEvent.getController());
  }
}

void customize(DropdownList ddl) {
  // a convenience function to customize a DropdownList
  ddl.setBackgroundColor(color(190));
  ddl.setItemHeight(20);
  ddl.setBarHeight(15);
  ddl.captionLabel().set("COM Port (USB to Serial)");
  ddl.captionLabel().style().marginTop = 3;
  ddl.captionLabel().style().marginLeft = 3;
  ddl.valueLabel().style().marginTop = 3;

  int len = Serial.list().length;  //get number of ports available
  for ( int i = 0; i < len; i++) { 
    ddl.addItem(Serial.list()[i], i);
  }

  //ddl.scroll(0);
  ddl.setColorBackground(color(60));
  ddl.setColorActive(color(255, 128));
}

/*
void findSerialPortx() {
 // Find Serial Port that the arduino is on 
 // The arduino is sending out a 'T' every 100 millisecs and 
 // checks to see if it got a 'G' back. 
 long millisStart; 
 int i = 0; 
 int len = Serial.list().length;  //get number of ports available 
 println(Serial.list());   //print list of ports to screen
 println("Serial Port Count = " + len); //print count of ports to screen
 for ( i = 0; i < len; i++) 
 { 
 println("Testing port " + Serial.list()[i]); 
 arduinoPort = new Serial(this, Serial.list()[i], 9600);    // Open 1st port in list 
 
 millisStart = millis(); 
 while ( (millis () - millisStart) < 2000) ; //wait for USB port reset (Guessed at 2 secs) 
 // can't use delay() call in setup() 
 
 arduinoPort.clear();    // empty buffer(incase of trash) 
 arduinoPort.bufferUntil('T');                   //buffer until there is a 'T'
 millisStart = millis(); 
 while ( (millis () - millisStart) < 100) ; //collect some chars
 if (arduinoPort.available() > 0)   //if we have a character 
 { 
 char c = arduinoPort.readChar(); //get the character 
 //println("Char available = " + c); 
 
 if (c == 'T')    //if we got a 'T' 
 { 
 arduinoPort.write('G');  //send a 'G' 
 break;    //leave for loop
 }
 } else 
 arduinoPort.stop();   //if no 'T', stop port
 println("Stop Port");
 } 
 println("Serial Port used = " + Serial.list()[i]);
 }
 */
